<?php
/* vim: set expandtab tabstop=2 shiftwidth=2: */
	
class util {
	function make_options($list, $val, $nosel = false) {
		$option = "";
		$sel_f = false;
		if ($list) foreach($list as $key => $value) {
			$sel = "";
			$sel_p = "";
      if ($val !== '' && $val !== null && $key == $val) {
				$sel = "selected";
				$sel_p = " (*)";
				$sel_f = true;
			} 
			$key = htmlspecialchars($key, ENT_QUOTES);
			$value = htmlspecialchars($value, ENT_QUOTES);
			$option .= "<option value='$key' $sel>$value$sel_p</option>\n";
		} 
		if ($nosel) {
			$option = "<option value=''>ꤷʤ</option>\n" . $option;
		} else if (!$sel_f) {
			$option = "<option value=''>򤷤Ʋ</option>\n" . $option;
		} 
		return $option;
	} 


	function make_date_field($rec, $field_name) {
		$ret = '';
		$y = $rec["{$field_name}_y"];
		$m = $rec["{$field_name}_m"];
		$d = $rec["{$field_name}_d"];
	
		$ret .= "<select name='{$field_name}_y'>\n";
		$ret .= "<option value=''>ʤ\n";
		for($i = $y-3; $i <= $y; $i++) {
			$ret .= "<option value='$i' $sel>$i\n";
		} 
		$ret .= "</select>\n";
		$ret .= "ǯ";
	
		$ret .= "<select name='{$field_name}_m'>\n";
		for($i = 1; $i <= 12; $i++) {
			if ($i == $m) $sel = 'selected';
			else $sel = '';
			$ret .= "<option value='$i' $sel>$i\n";
		} 
		$ret .= "</select>\n";
		$ret .= "";
	
		$ret .= "<select name='{$field_name}_d'>\n";
		for($i = 1; $i <= 31; $i++) {
			if ($i == $d) $sel = 'selected';
			else $sel = '';
			$ret .= "<option value='$i' $sel>$i\n";
		} 
		$ret .= "</select>\n";
		$ret .= "";
	
		return $ret;
	} 

	
	function str2number($num) {
		return trim(str_replace(',', '', $num));
	} 

	
	function str2date($date) {
		$date = trim($date);
		if (preg_match("/^(\d{4})[-\/](\d{1,2})[-\/](\d{1,2})/", $date, $match)) {
			return sprintf("%04d/%02d/%02d", $match[1], $match[2], $match[3]);
		} else {
			return '';
		} 
	} 

	function str2datetime($date) {
		$date = trim($date);
		if (preg_match("/^(\d{4})[-\/](\d{1,2})[-\/](\d{1,2})\s*(\d{1,2}):(\d{1,2}):(\d{1,2})/", $date, $match)) {
			return sprintf("%04d/%02d/%02d %02d:%02d:%02d", $match[1], $match[2], $match[3], $match[4], $match[5], $match[6]);
		} else {
			return '';
		} 
	} 

	
	function kanji_date($datetime) {
		return strftime('%Yǯ%m%d', strtotime($datetime));
	} 


  function tpl_send_mail($msg) {
    $msg = output_filter($msg);

    mb_language('ja');
    $msg = str_replace("<br>", "\n", $msg);
    $msg = str_replace("\r", "", $msg);
    $mail_tmp = split("\n", $msg);

  /***/
  $fp=fopen("/tmp/tpl_send_mail", "a");
  if ($fp) {
    ob_start();
    var_dump($mail_tmp);
    fwrite($fp, ob_get_contents());
    fwrite($fp, "---------------------\n");
    ob_end_clean();
    fclose($fp);
  }
  /***/

    $mail_header = "";
    $mail_body = "";
    $header_f = true;
    $body_f = false;
    foreach($mail_tmp as $tmp) {
      $tmp = trim($tmp);
      if ($header_f && $tmp) {
        if (preg_match('/^From:/i', $tmp)) {
          if (preg_match('/.*["\'](.*)["\'].*<(.*)>/', $tmp, $tmp1)) {
            $tmp2 = mb_encode_mimeheader($tmp1[1], 'JIS');
            $mail_header .= "From: \"$tmp2\" <{$tmp1[2]}>\n";
          } else {
            preg_match('/.*:(.*)/', $tmp, $tmp1);
            $mail_header .= trim($tmp1[1]) . "\n";
          }
        }
        if (preg_match('/^cc:/i', $tmp)) {
          preg_match('/.*:(.*)/', $tmp, $tmp1);
          if (trim($tmp1[1])) {
            $tmp1[1] = str_replace(';', ',', $tmp1[1]);
            $mail_header .= "cc:" . trim($tmp1[1]) . "\n";
          }
        }
        if (preg_match('/^Bcc:/i', $tmp)) {
          preg_match('/Bcc:(.*)/', $tmp, $tmp1);
          if (trim($tmp1[1])) {
            $tmp1[1] = str_replace(';', ',', $tmp1[1]);
            $mail_header .= "Bcc:" . trim($tmp1[1]) . "\n";
          }
        }
        if (preg_match('/^To:/i', $tmp)) {
          preg_match('/To:(.*)/', $tmp, $tmp1);
          $mail_to = trim($tmp1[1]);
        }
        if (preg_match('/^Subject:/i', $tmp)) {
          preg_match('/Subject:(.*)/', $tmp, $tmp1);
          $mail_subject = trim($tmp1[1]);
        }
        continue;
      }
      if ($header_f && !$tmp) {
        $header_f = false;
        continue;
      }
      if ($header_f == false && $body_f == false) {
        if (!$tmp) continue;
        $body_f = true;
      }
      $mail_body .= $tmp . "\n";
    }
    mb_send_mail($mail_to, $mail_subject, $mail_body, $mail_header, '-f'.MAIL_RETURN_PATH);

    global $__trace_mode_log;
    if ($__trace_mode_log) {
        pm9mvc::log("mail:$mail_to  $mail_subject");
    }

    sleep(1);

  }


  function get_system_id() {
    global $__sess;

    pm9mvc::_check_args(func_get_args(), 'pm9mvc::get_system_id',
      array());

    return $__sess['_SYSTEM_ID'];
  }

  function set_system_id($id) {
    global $__sess;

    pm9mvc::_check_args(func_get_args(), 'pm9mvc::set_system_id',
      array('system_id' => 'str'));

    $__sess['_SYSTEM_ID'] = $id;
  }


  function count_error_list($list) {
    $co = 0;
    if (!is_array($list)) return;
    foreach($list as $tmp) {
      if (is_array($tmp)) {
        $co += util::count_error_list($tmp);
      } else if (!$tmp) {
      } else {
        $co++;
      }
    }
    return $co;
  }
}
?>
